# Gammon IV (VT100 ANSI edition)

By:
	David C. Oshel
	1219 Harding Ave.
	Ames, Iowa 50010

This is a patched version of "Gammon IV, Version 2.0, April 1, 1986", a full-screen backgammon for CP/M.

I patched the game to use VT100 compatible escape sequences (including ANSI color).

Therefore, I removed most of the "user patch area" and hardcoded the VT100 sequences in the C code,
replaced the asm code of gotoxy() with C code and removed the Kaypro graphics routines 
(and the "G(raphics" command) as it is not needed for my VT100 version.

``BACKGMMN.COM`` is the compiled and ready-to-run game.

Have fun playing!

Anna Christina Naß <acn@acn.wtf>

## Compiling the game

See [Compiler/Compiling.md](Compiler/Compiling.md) for information on compiling the game on CP/M.

## From the original Version 2.0 READ.ME:

Improvements for Version 2.0 include:

a)  Several bugs and poltergeists, especially in the Arrange command, have been completely exorcised.  No bugs have been found in the Play command for months; but, as before, Gammon IV will not invariably recognize a forced move, either in your play or in its own.  Gammon IV knows and obeys all other official rules of backgammon.

b)  There are no "hidden" commands anymore.  All commands are now shown in the command lines, including X(pert.

c)  Input error handling now documents the BAR, HOME and HELP commands, so first-time players do not need to read anything else in order to play the game successfully.  The X(pert mode dispenses with these messages, so X(pert actually does mean expert, now!

d)  The "break" command is Control-C again, instead of ESCAPE.  It was all too easy to hit ESC instead of 1 on the Kaypro keyboard, leading to an inadvertently paused game.

e)  The sanction against cheating (your opponent became Torve) has been removed.

f)  If the cube is doubled during the opening rolloff to see who goes first, and the cube value reaches 8, additional pairs on the dice have no further effect. The cube's opening value will not go above 8.

The computer's three styles of play have not been changed.  Judging from the feedback I've received, Gammon IV plays acceptably well at the current levels.  All information needed to re-compile the program is included in the BACKGMMN.C file, including the details of C/80 3.1 configuration.  The compile and link steps are governed by BACKGMMN.SUB.

This program is in the public domain, so distribute it freely.

Enjoy!

    David C. Oshel
    1219 Harding Ave.
    Ames, Iowa 50010

