#!/bin/bash

imagefile=./VT100games-HD.img

filelist="
	2048/2048.COM
	Backgammon/backgmmn.com
	Battleships/bs.com
	Blocks/BLOCKS.COM
	CatChum/CATCHUM.COM
	CatChum/CATCHUM.DAT
	cpmtris/cpmtris.com
	FindThatMine/ftm.com
	Ladder/LADDER.COM
	Ladder/LADDER.DAT
	MazezaM/mazezam.com
	Pac/pac.com
	Quatris/QUATRIS.COM
	Quatris/QUATRIS.SCO
	RobotChase/chase.com
	Robots/ROBOTS.COM
	Rogue/rogue.com
	Snake/SNAKE.COM
	Sokoban/sokoban.com
	Sokoban/soklevls.dat
	Worm/worm.com
"

dirlist="
	2048	Backgammon	Battleships	Blocks	CatChum	cpmtris		FindThatMine
	Ladder	LadderTP	MazezaM		Pac		Quatris	RobotChase	Robots
	Rogue	Snake		Sokoban		Worm
"

wanderer="
	screen.*
	wanderer.com
	wanderer.doc
"

[ ! -d u0 ] && mkdir u0
[ ! -d u1 ] && mkdir u1

rm -f u0/* u1/*

for i in ${filelist}; do
	target=`basename $i`
	cp -v ../$i u0/${target^^}
done
for i in ${wanderer}; do cp -v ../Wanderer/$i u1; done
cp -v ../LadderTP/LADDER.COM u0/TLADDER.COM
cp -v ../LadderTP/LADDER.DAT u0/TLADDER.DAT
for i in u1/*; do
	target=`basename $i`
	mv $i u1/${target^^}
done

for i in ${dirlist}; do
	pandoc -f markdown -t plain -s ../$i/README.md -o u0/${i^^}.DOC
done

cd u0
mv BACKGAMMON.DOC	BACKGMMN.DOC
mv BATTLESHIPS.DOC	BS.DOC
mv ROBOTCHASE.DOC	CHASE.DOC
mv FINDTHATMINE.DOC	FTM.DOC
mv LADDERTP.DOC		TLADDER.DOC
cd ..

mkfs.cpm -fz80pack-hd $imagefile
cpmcp -f z80pack-hd $imagefile u0/* 0:
cpmcp -f z80pack-hd $imagefile u1/* 1:

echo ""
echo "Fertig!"

