# MazezaM

MazezaM is a puzzle game for CP/M.

* Copyright (C) 2002 Malcolm  Tyrrell <tyrrelmr@cs.tcd.ie>
* CP/M version (C) 2004-2008 Ventzislav Tzvetkov (drHirudo) (for VT52 terminals)
* z88dk version by Stefano Bodrato (www.z88dk.org)
* VT100 adaption (C) 2020 Anna Christina Naß <acn@acn.wtf>

Licensed under the GPL.

You can find the VT52 version of this game, and also for other platforms, here: http://hirudov.com/

## The game

MazezaM (pronounced "may-zam") is a simple puzzle game. You enter the
mazezam on the left and you have to get to the exit on the right by
pushing rows of blocks left and right.

In the game ``=`` represents a brick, ``#`` represents a block, ``P`` is the Player
and ``O`` is a door. 
Good Luck.

## Keys

I changed the keys to 8, 6, 4, 2 on the numpad, but W, A, S, D will also work.
Use R to restart a level (at the cost of one live).

## About the game, by drHirudo

To the best of my knowledge MazezaM's specific game logic is original.
Unfortunately, there are so many puzzles out there that it is impossible for
me to be sure. If you are aware of a prior instance of the idea, please get
in touch. If possible, include a link which I can add to my web page.

The idea for MazezaM came to me while recalling an Oric-1 type-in game
called "Fall Guy" (from the book "Sixty Programs for the Oric-1" by Robert
Erskine, Humphrey Walwyn, Paul Stanley and Michael Bews). The game play is a
reminiscent of the game Sokoban (Thinking Rabbit, Inc) and also bears a
resemblance to "sliding block" or "sliding piece" puzzles where wooden shapes
are moved around in order to get a (usually larger) shape from one side of the
puzzle to the other. The name "MazezaM" was suggested by Robert Byrne.

## Compiling

MazezaM is written in C for the ZXCC compiler which can be found in [z88dk](https://www.z88dk.org/).

Use this command line (tested in Linux) to compile:

	zcc +cpm -lndos -o MAZEZAM.COM mazezam.c -O3

## New Levels Wanted:

If you like this game and are good at designing levels, I encourage you to
create levels and send them to any of the authors for include  in  further
versions. Credit of course will be given.

## Other versions and games my drHirudo

Original Sinclair and Java games - Copyright (C) 2002 Malcolm Tyrrell
http://www.cs.tcd.ie/Malcolm.Tyrrell/

Amiga Version
Copyright (C) 2003-2004 Ventzislav Tzvetkov
http://hirudov.com/

Gameboy Version
Copyright (C) 2003-2004 Ventzislav Tzvetkov
http://hirudov.com/
Developed using GBDK v2.1.0-1 and Wzonka-Lad 1.03.00.

Oric Atmos Version
Copyright (C) 2004 Ventzislav Tzvetkov
http://hirudov.com/

Apple II Version
Copyright (C) 2004 Ventzislav Tzvetkov
http://hirudov.com/

Commodore 64 Version
Copyright (C) 2004 Ventzislav Tzvetkov
http://hirudov.com/

SNES version
Copyright (C) 2004-2006 Ventzislav Tzvetkov
http://hirudov.com/

CP/M version
Copyright (C) 2004-2008 Ventzislav Tzvetkov
http://hirudov.com/
Compiled using Z88DK on AmigaOS 4.
Tested under DOSBox and MYZ80 emulator.

